const
  isLocal : Boolean = False;         { Are we running Local Only? }
  isStats : Boolean = True;          { Is the status bar dislplayed? }
  FirstTime : Boolean = True;        { Has the status bar been drawn yet? }

  isExtended : Boolean = False;      { Is the current input char Extended }

  DropType : Byte = 0;               { 0 = local
                                       1 = door.sys
                                       2 = door32.sys }

  StatFore  : Byte = $0F;
  StatBack  : Byte = $01;
  PAUSE_STRING  : String = '`0A<PAUSE>'; {Modify this!}

  ASCII_GRAPH   : Integer = 0;
  ANSI_GRAPH    : Integer = 1;
  AVT_GRAPH     : Integer = 2;
  RIP_GRAPH     : Integer = 3;
  MAX_GRAPH     : Integer = 4;

{ User record, this is where info from dropfiles is stored }

Type TUserInfo = Record
  RealName  : String;
  Handle    : String;
  CityState : String;
  ACS       : LongInt;
  TimeLeft  : LongInt;
  TotalTime : LongInt;
  ComPort   : LongInt;
  ConnType  : Byte;                {0 = local, 1 = modem, 2 = telnet}
  Baud      : LongInt;
  Node      : String[3];
  GraphMode : Byte;
  DropFile  : String;
  DropType  : Byte;
  {Available only when DOOR32.SYS is used}
  BBSID     : String;              {BBS name and version, ie: "Mystic 1.07"}
  RecPos    : LongInt;             {User record position in BBS data file}
end;

(* Not used yet *)
Type TMenu = Record
  Title     : String[20];                 { Title of menu }
  HiFore    : Byte;                       { Highlight Colours }
  HiBack    : Byte;
  MnuFore   : Byte;                       { Menu Colours }
  MnuBack   : Byte;
  NumOpts   : Integer;
  DfltOpt   : Integer;                    { Number of Default Option }
  Options   : Array[1..20] of String[20]; { Max 20 Options }
end;

Type TTime = Record
  Hours : word;
  Minutes : word;
  Sec : word;
  MSec : word;
end;

Var
  DoorStartTime : LongInt;              { Store Time in seconds when door started }
  LastTime      : LongInt;              { Used for UpdateStatBar }
  UserInfo      : TUserInfo;            { User info variable }
  STime         : TTime;                { Door system variables }
